#include <s_globals.h>
#include <s_util.h>

#define PRINT_FD 1

void print_raw ( char *raw )
{
	//CRITICAL_START(globals.glock);
	write(PRINT_FD, raw, strlen(raw));
	if (!globals.nosync) fsync(PRINT_FD);
	//CRITICAL_STOP(globals.glock);
}

int print_out(char *format, ...)
{
	va_list va;
	char output[BUFFER_SIZE];
	char *p=(char *)&output;

	memset(p, 0, BUFFER_SIZE);

	if ( format == NULL ) return 0;

	va_start(va, format);
	vsnprintf(p, BUFFER_SIZE-1, format, va);
	va_end(va);

	//CRITICAL_START(globals.glock);
	write(PRINT_FD, p, strlen(p));
	if (!globals.nosync) fsync(PRINT_FD);
	//CRITICAL_STOP(globals.glock);
	
	return 1;
}

int atomic_inc_counter(p_atomic_counter c)
{
	CRITICAL_START(c->lock);
	c->counter++;
	CRITICAL_STOP(c->lock);
	return c->counter;
}

int atomic_dec_counter(p_atomic_counter c)
{
	CRITICAL_START(c->lock);
	c->counter--;
	CRITICAL_STOP(c->lock);
	return c->counter;
}
